Scriptname _MWA_ArmorAlias extends ReferenceAlias  

Float Property LastUpdate = 0.0 Auto Hidden

Bool Property IsSafe = false Auto Hidden

Actor Property PlayerRef Auto

Faction Property CurrentFollowerFaction Auto

Keyword Property LocTypePlayerHouse Auto

ObjectReference Property WhatIAm Auto Hidden ; Because Self.GetReference has also started returning [Item x in container] bullshit

Event OnContainerChanged(ObjectReference akNewContainer, ObjectReference akOldContainer) ; For Broken object tracking
	;Debug.Trace("_MWA_: ContainerChange: " + WhatIAm)
	IsSafe = true ; Set true in case of timing, until true IsSafe is known
	Bool IsSafeTemp = false
	Location ObjLocation
	If WhatIAm != None
		ObjLocation = WhatIAm.GetCurrentLocation()
	EndIf
	If akNewContainer == PlayerRef
		IsSafeTemp = true
	ElseIf ObjLocation != None
		If ObjLocation.HasKeyword(LocTypePlayerHouse)
			IsSafeTemp = true
		EndIf
	ElseIf akNewContainer as Actor
		If (akNewContainer as Actor).IsInFaction(CurrentFollowerFaction)
			IsSafeTemp = true
		EndIf
	EndIf
	IsSafe = IsSafeTemp
	If IsSafe
		LastUpdate = Utility.GetCurrentGameTime()
	EndIf
EndEvent

Event OnEquipped(Actor akActor) ; For object Tracking
	If akActor == PlayerRef
		LastUpdate = Utility.GetCurrentGameTime()
	EndIf
endEvent
