Scriptname _MWA_CellChange extends Quest  

Function CellChanged()
	;Utility.Wait(0.1)
	;Debug.Trace("_MWA_: Player changed cells ++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++")
	_MWA_CellChangeDetectObjRef.MoveTo(PlayerRef)
	If Menu.NpcDegradationScanT
		_MWA_NpcDegradationQuest.Stop()
		_MWA_NpcDegradationQuest.Start()
		_MWA_NpcDeadDegradationQuest.Stop()
		_MWA_NpcDeadDegradationQuest.Start()
	EndIf
	If Menu.WorldObjectScanT
		_MWA_ScanWorldObjectsQuest .Stop()
		_MWA_ScanWorldObjectsQuest .Start()
	EndIf
	If Menu.ContainerScanT
		_MWA_ScanContainersQuest.Stop()
		_MWA_ScanContainersQuest.Start()
	EndIf
	
	Bool IsInside = PlayerRef.IsInInterior()
	If Menu.RemoveFoodWorldT
		_MWA_RemoveWorldFoodObjectsQuest.Stop()
		_MWA_RemoveWorldFoodObjectsQuest.Start()
		If IsInside
			While (_MWA_RemoveWorldFoodObjectsQuest.GetNthAlias(9) as ReferenceAlias).GetReference() != None
				;Debug.Messagebox("Looping")
				_MWA_RemoveWorldFoodObjectsQuest.Stop()
				Utility.Wait(0.1)
				_MWA_RemoveWorldFoodObjectsQuest.Start()
			EndWhile
		EndIf
	EndIf

	If Menu.ContainerScanT && IsInside ; Do initial sweep first above to check containers close to the player. Then if inside keep checking
		;Debug.Trace("_MWA_: 1 - Aliases: " + (_MWA_ScanContainersQuest.GetNumAliases() - 1) + ". Contains: " + (_MWA_ScanContainersQuest.GetNthAlias(0) as ReferenceAlias).GetReference())
		While (_MWA_ScanContainersQuest.GetNthAlias(19) as ReferenceAlias).GetReference() != None
			_MWA_ScanContainersQuest.Stop()
			Utility.Wait(1.0)
			_MWA_ScanContainersQuest.Start()
		EndWhile
	EndIf
EndFunction

Quest Property _MWA_NpcDegradationQuest Auto
Quest Property _MWA_NpcDeadDegradationQuest Auto
Quest Property _MWA_ScanWorldObjectsQuest Auto
Quest Property _MWA_ScanContainersQuest Auto
Quest Property _MWA_RemoveWorldFoodObjectsQuest Auto

Actor Property PlayerRef Auto

ObjectReference Property _MWA_CellChangeDetectObjRef Auto

_MWA_Mcm Property Menu Auto
