Scriptname _MWA_CombatMagic extends ReferenceAlias  

State CoolOff
	Event OnMagicEffectApply(ObjectReference akCaster, MagicEffect akEffect)
		
	EndEvent
EndState

Event OnMagicEffectApply(ObjectReference akCaster, MagicEffect akEffect)
	GoToState("CoolOff")
	Keyword MagicKeyword = None
	If akEffect.HasKeyword(MagicDamageFire)
		MagicKeyword = MagicDamageFire
	ElseIf akEffect.HasKeyword(MagicDamageFrost)
		MagicKeyword = MagicDamageFrost
	ElseIf akEffect.HasKeyword(MagicDamageShock)
		MagicKeyword = MagicDamageShock
		
	ElseIf akEffect.HasKeyword(MagicShout)
		If akEffect == VoiceUnrelentingForceEffect01
			MagicKeyword = _MWA_ShoutForce1
		ElseIf akEffect == VoiceUnrelentingForceEffect02
			MagicKeyword = _MWA_ShoutForce2
		ElseIf akEffect == VoiceUnrelentingForceEffect03
			MagicKeyword = _MWA_ShoutForce3
		EndIf
	EndIf
	
	If MagicKeyword != None
		Util.RelayArmorHit(MagicKeyword)
		Utility.Wait(Menu.MagicDegradeCooldown) ; otherwise continous spells like Fire Sparks will just melt armor
	EndIf
	GoToState("")
EndEvent

Keyword Property MagicDamageFire Auto
Keyword Property MagicDamageFrost Auto
Keyword Property MagicDamageShock Auto
Keyword Property MagicShout Auto

Keyword Property _MWA_ShoutForce1 Auto
Keyword Property _MWA_ShoutForce2 Auto
Keyword Property _MWA_ShoutForce3 Auto

MagicEffect Property VoiceUnrelentingForceEffect01 Auto
MagicEffect Property VoiceUnrelentingForceEffect02 Auto
MagicEffect Property VoiceUnrelentingForceEffect03 Auto

_MWA_Utility Property Util Auto
_MWA_Mcm Property Menu Auto
