Scriptname _MWA_DestructionTypes extends Quest   

_MWA_Mcm Property Menu Auto
_MWA_Init Property Init Auto
_MWA_Utility Property Util Auto

Formlist Property _MWA_ImmuneList Auto

Keyword Property _MWA_Broken Auto
Keyword Property DaedricArtifact Auto
Keyword Property ArmorClothing Auto
Keyword Property ArmorLight Auto
Keyword Property ArmorHeavy Auto
Keyword Property ArmorShield Auto
Keyword Property ArmorJewelry Auto
Keyword Property _MWA_Immune Auto

Function UpdateState()
	; 0 - Original -> ""
	; 1 - Original + Misc -> "Misc"
	; 2 - Original + Daedric -> "Daedric"
	; 3 - Original + Misc + Daedric -> "MiscDaedric"

	If Menu.DestructableTypes == 0
		GoToState("")
	ElseIf  Menu.DestructableTypes == 1
		GoToState("Misc")
	ElseIf  Menu.DestructableTypes == 2
		GoToState("Daedric")
	Else 
		GoToState("MiscDaedric")
	EndIf
EndFunction

Bool Function IsDestructible(Form akBaseObject)
	If !_MWA_ImmuneList.HasForm(akBaseObject) && !akBaseObject as Hazard ; How the fuck are Hazards making it to the wornlist?!?!?
		If akBaseObject as Armor
			If ((!akBaseObject.HasKeyword(_MWA_Broken) && akBaseObject.IsPlayable() && !akBaseObject.HasKeyword(DaedricArtifact) && !akBaseObject.HasKeyword(_MWA_Immune) && !Util.HasZadInvDeviceKeyword(akBaseObject) && !Util.HasNoStripKeyword(akBaseObject)) && (akBaseObject.HasKeyword(ArmorClothing) ||  akBaseObject.HasKeyword(ArmorLight) ||  akBaseObject.HasKeyword(ArmorHeavy) || akBaseObject.HasKeyword(ArmorShield)))
				Return true
			EndIf
		
		ElseIf akBaseObject as Weapon
			If (!akBaseObject.HasKeyword(_MWA_Broken) && akBaseObject.IsPlayable() && !akBaseObject.HasKeyword(DaedricArtifact) && !akBaseObject.HasKeyword(_MWA_Immune) && !Util.HasNoStripKeyword(akBaseObject))
				Return true
			EndIf
		EndIf
	EndIf
	Return false
EndFunction


State Misc
	Bool Function IsDestructible(Form akBaseObject)
		If !_MWA_ImmuneList.HasForm(akBaseObject) && !akBaseObject as Hazard ; How the fuck are Hazards making it to the wornlist?!?!?
			If akBaseObject as Armor
				If ((!akBaseObject.HasKeyword(_MWA_Broken) && akBaseObject.IsPlayable() && !akBaseObject.HasKeyword(DaedricArtifact) && !akBaseObject.HasKeyword(_MWA_Immune) && !Util.HasZadInvDeviceKeyword(akBaseObject) && !Util.HasNoStripKeyword(akBaseObject)) && (akBaseObject.HasKeyword(ArmorClothing) ||  akBaseObject.HasKeyword(ArmorLight) ||  akBaseObject.HasKeyword(ArmorHeavy) || akBaseObject.HasKeyword(ArmorShield) || akBaseObject.HasKeyword(ArmorJewelry)))
					Return true
				EndIf
			
			ElseIf akBaseObject as Weapon
				If (!akBaseObject.HasKeyword(_MWA_Broken) && akBaseObject.IsPlayable() && !akBaseObject.HasKeyword(DaedricArtifact) && !akBaseObject.HasKeyword(_MWA_Immune) && !Util.HasNoStripKeyword(akBaseObject))
					Return true
				EndIf
			EndIf
		EndIf
		Return false
	EndFunction
EndState

State Daedric
	Bool Function IsDestructible(Form akBaseObject)
		If !_MWA_ImmuneList.HasForm(akBaseObject) && !akBaseObject as Hazard ; How the fuck are Hazards making it to the wornlist?!?!?
			If akBaseObject as Armor
				If ((!akBaseObject.HasKeyword(_MWA_Broken) && akBaseObject.IsPlayable() && !Util.HasZadInvDeviceKeyword(akBaseObject) && !akBaseObject.HasKeyword(_MWA_Immune) && !Util.HasNoStripKeyword(akBaseObject)) && (akBaseObject.HasKeyword(ArmorClothing) ||  akBaseObject.HasKeyword(ArmorLight) ||  akBaseObject.HasKeyword(ArmorHeavy) || akBaseObject.HasKeyword(ArmorShield)))
					Return true
				EndIf
			
			ElseIf akBaseObject as Weapon
				If (!akBaseObject.HasKeyword(_MWA_Broken) && akBaseObject.IsPlayable() && !akBaseObject.HasKeyword(_MWA_Immune) && !Util.HasNoStripKeyword(akBaseObject))
					Return true
				EndIf
			EndIf
		EndIf
		Return false
	EndFunction
EndState

State MiscDaedric
	Bool Function IsDestructible(Form akBaseObject)
		If !_MWA_ImmuneList.HasForm(akBaseObject) && !akBaseObject as Hazard ; How the fuck are Hazards making it to the wornlist?!?!?
			If akBaseObject as Armor
				If ((!akBaseObject.HasKeyword(_MWA_Broken) && akBaseObject.IsPlayable() && !Util.HasZadInvDeviceKeyword(akBaseObject) && !akBaseObject.HasKeyword(_MWA_Immune) && !Util.HasNoStripKeyword(akBaseObject)) && (akBaseObject.HasKeyword(ArmorClothing) ||  akBaseObject.HasKeyword(ArmorLight) ||  akBaseObject.HasKeyword(ArmorHeavy) || akBaseObject.HasKeyword(ArmorShield) || akBaseObject.HasKeyword(ArmorJewelry)))
					Return true
				EndIf
			
			ElseIf akBaseObject as Weapon
				If (!akBaseObject.HasKeyword(_MWA_Broken) && akBaseObject.IsPlayable() && !akBaseObject.HasKeyword(_MWA_Immune) && !Util.HasNoStripKeyword(akBaseObject))
					Return true
				EndIf
			EndIf
		EndIf
		Return false
	EndFunction
EndState
