Scriptname _MWA_DroppedEquipGlow extends ReferenceAlias  

Actor Property PlayerRef Auto

EffectShader Property Glow Auto

ObjectReference Aura
Activator Property AuraEffect Auto
GlobalVariable Property _MWA_DetectEquipmentRunning Auto

Event OnInit()
	;Debug.Trace("_MWA_: New: Glow INIT")
	RegisterForControl("Forward")
	RegisterForControl("Back")
	BeginGlow()
EndEvent

Event OnControlDown(string control)
	UnRegisterForAllControls()
	EndGlow()
EndEvent

Function BeginGlow()
	If Self.GetReference() != None
		;Debug.Trace("_MWA_: New: Glowing: " + Self.GetReference().GetBaseObject().GetName())
		Aura = Self.GetReference().PlaceAtMe(AuraEffect)
		Aura.MoveTo(Aura, afZOffset = 48)
		Utility.Wait(0.1)
		Glow.Play(Self.GetReference())
	EndIf
EndFunction

Function EndGlow()
	If Self.GetReference() != None
		;Debug.Trace("_MWA_: Glow ENDING on " + Self.GetReference().GetBaseObject().GetName())
		Glow.Stop(Self.GetReference())
		Glow.Stop(Aura)
		Aura.Disable()
		Aura.Delete()
	EndIf
	_MWA_DetectEquipmentRunning.SetValueInt(0)
	Self.GetOwningQuest().Stop()
EndFunction
