Scriptname _MWA_InterfaceSexlab extends Quest  

Quest SexLabQuest

Faction SexLabAnimatingFaction

Function PlayerLoadsGame()
	If Game.GetModByName("SexLab.esm") != 255
		If GetState() != "Installed"
			GoToState("Installed")
		EndIf
	
	Else
		If GetState() != ""
			GoToState("")
		EndIf
	EndIf
EndFunction

Bool Function GetIsInterfaceActive()
	If GetState() == "Installed"
		Return true
	EndIf
	Return false
EndFunction

State Installed
	Bool Function GetIsVictim(Int tid, Actor akActor)
		Return _MWA_IntSexlab.GetIsVictim(tid, akActor, SexLabQuest)
	EndFunction

	Bool Function GetIsAnimating(Actor akActor)
		If akActor.IsInFaction(SexLabAnimatingFaction)
			Return true
		Else
			Return false
		EndIf
	EndFunction
EndState

Event OnEndState()
	Utility.Wait(5.0) ; Wait before entering active state to help avoid making function calls to scripts that may not have initialized yet.
	SexLabQuest = Game.GetFormFromFile(0x000D62, "SexLab.esm") as Quest
	SexLabAnimatingFaction = Game.GetFormFromFile(0xE50F, "Sexlab.esm") as Faction
EndEvent

Bool Function GetIsVictim(Int tid, Actor akActor)
	Return false
EndFunction

Bool Function GetIsAnimating(Actor akActor)
	Return false
EndFunction
