Scriptname _MWA_PlayerInvAlias extends ReferenceAlias  

_MWA_PlayerInventoryUtil Property InvUtil Auto
_MWA_Utility Property Util Auto

Actor Property PlayerRef Auto

ObjectReference WhereIAm

Function AddToContainer(ObjectReference DestContainer)
	WhereIAm = DestContainer
	;Debug.Trace("_MWA_: New: " + Self.GetReference() + " moved into " + DestContainer)
	If DestContainer != PlayerRef
		DoUpdate() ; Make sure an update is queued as OnContainerChanged is a piece of shit
	EndIf
EndFunction


Event OnContainerChanged(ObjectReference akNewContainer, ObjectReference akOldContainer)
	WhereIAm = akNewContainer
	;Debug.Trace("_MWA_: New: " + Self.GetReference() + " moved to " + akNewContainer)
	If WhereIAm != PlayerRef
		ObjectReference ObjRef = Self.GetReference()
		StorageUtil.FormListRemove(ObjRef.GetBaseObject(), "_MWA_Inv_ObjRefs", ObjRef) ; But keep list up to date
	EndIf
	DoUpdate() ; If object were to quickly leave the player and return within a second (tempering/repair etc), do nothing
EndEvent


Function DoUpdate()
	GoToState("InProc")
	If !InvUtil.IsShopping
		Utility.WaitMenuMode(1.0)
	EndIf
	If WhereIAm != PlayerRef
		;Debug.Notification("Removing " + Self.GetReference().GetBaseObject().GetName() + " from inv")
		;Debug.Trace("_MWA_: New: Removing" + Self.GetReference() + " from inv")
		ObjectReference ObjRef = Self.GetReference()
		If ObjRef
			StorageUtil.FormListRemove(ObjRef.GetBaseObject(), "_MWA_Inv_ObjRefs", ObjRef, true)
			InvUtil.ReleaseAlias(Self.GetId(), ObjRef)
		Else
			Debug.Trace("_MWA_: PlayerInvAlias1: None ObjRef - Alias: " + Self.GetId())
		EndIf
		
	Else
		ObjectReference ObjRef = Self.GetReference()
		If ObjRef
			StorageUtil.FormListAdd(ObjRef.GetBaseObject(), "_MWA_Inv_ObjRefs", ObjRef)
		Else
			Debug.Trace("_MWA_: PlayerInvAlias2: None ObjRef - Alias: " + Self.GetId())
		EndIf
		;Debug.Trace("_MWA_: New: " + Self.GetReference() + " is back with the player. Doing nothing")
		;Debug.Notification(Self.GetReference().GetBaseObject().GetName() + " is back with the player. Doing nothing")
	EndIf
	GoToState("")
EndFunction

State InProc
	Function DoUpdate()
	
	EndFunction
EndState
