Scriptname _MWA_ScanWorldObjectsAlias extends ReferenceAlias  

_MWA_Mcm Property Menu Auto
_MWA_Utility Property Util Auto
_MWA_DestructionTypes Property DestTypes Auto
Quest Property _MWA_AliasesWorldObjects Auto

Event OnInit()
	ObjectReference ObjRef = Self.GetReference()
	If ObjRef
		Form akBaseObject = ObjRef.GetBaseObject()
		If DestTypes.IsDestructible(akBaseObject )
			If StorageUtil.GetIntValue(ObjRef, "_MWA_IsCursedObject", Missing = -1) < 0 && Menu.CursedChanceContainer > Utility.RandomFloat(0.0, 100.0) && !Util.IsInStore
				StorageUtil.SetIntValue(ObjRef, "_MWA_IsCursedObject", 1)
				Util.FitToPlayer(ObjRef, akBaseObject, FitLoosely = true)
			Else
				StorageUtil.SetIntValue(ObjRef, "_MWA_IsCursedObject", 0)
				Util.FitToRandom(ObjRef, akBaseObject)
			EndIf
			Util.FitToRandom(ObjRef, akBaseObject)
			Util.GetDurability(ObjRef, akBaseObject, ForceUpdate = false, IsWorn = !Util.IsInStore)
		EndIf
	EndIf
EndEvent
