Scriptname _MWA_AutoFit extends Quest  

Event OnInit()
	RegisterForMenu("Dialogue Menu")
	RegisterForMenu("Console")
	RegisterForMenu("Journal Menu")
EndEvent

Event OnMenuOpen(String MenuName)
	If !(MenuName == "Journal Menu")
		GoToState("Active")
	EndIf
EndEvent
;/
Event OnBeginState()
	Debug.Notification("Idle")
EndEvent
/;
Event OnMenuClose(String MenuName)
	If MenuName == "Journal Menu"
		StoredFitOption = Menu.EverythingFits
	EndIf
EndEvent

State Active
	Event OnBeginState()
		;Debug.Notification("Active")
		Menu.EverythingFits = true
	EndEvent
	
	Event OnEndState()
		Menu.EverythingFits = StoredFitOption
	EndEvent
	
	Event OnMenuClose(String MenuName)
		If MenuName == "Journal Menu"
			StoredFitOption = Menu.EverythingFits
		
		Else
			If !UI.IsMenuOpen("Dialogue Menu") && !UI.IsMenuOpen("Console")
				GoToState("")
			EndIf
		EndIf
	EndEvent
EndState

Bool StoredFitOption

_MWA_Mcm Property Menu Auto
