Scriptname _MWA_BrokenItem extends ObjectReference  

Event OnEquipped(Actor akActor)
	If akActor ; ?????
		akActor.UnequipItem(Self.GetBaseObject(), abPreventEquip = false, abSilent = false)
		If akActor == PlayerRef
			Debug.Notification("This item has degraded badly and can not be equipped")
		EndIf
	EndIf
endEvent


Event OnContainerChanged(ObjectReference akNewContainer, ObjectReference akOldContainer)
	If akNewContainer as Actor
		If akNewContainer == PlayerRef
			; Update LastUpdate
			Int AliasIndex = StorageUtil.FormListFind(none, "_MWA_BrokenTrackAliasList", Self)
			ReferenceAlias RefAlias = _MWA_BrokenTrack.GetNthAlias(AliasIndex) as ReferenceAlias
			If RefAlias != None
				If RefAlias.GetReference() != None
					If RefAlias == MyRef
						(RefAlias as _MWA_ArmorAlias).LastUpdate = Utility.GetCurrentGameTime()
					Else
						Debug.Trace("_MWA_: Error: RefAlias != MyRef")
					EndIf
				EndIf
			Else
				Debug.Trace("_MWA_: Error: BrokenItem - RefAlias = None")
			EndIf
		EndIf
	EndIf
EndEvent

ReferenceAlias Property MyRef Auto Hidden

Actor Property PlayerRef Auto

Quest Property _MWA_BrokenTrack Auto
