Scriptname _MWA_BrokenUpdate extends Quest  

Event OnUpdateGameTime()
	;float ftimeStart = Utility.GetCurrentRealTime()
	Int NumAliases = _MWA_BrokenTrack.GetNumAliases()
	Int i = 0
	ReferenceAlias CurrentAlias
	While i < NumAliases
		CurrentAlias = _MWA_BrokenTrack.GetNthAlias(i) as ReferenceAlias
		If CurrentAlias.GetReference() != None
			If (CurrentAlias as _MWA_ArmorAlias).IsSafe
				(CurrentAlias as _MWA_ArmorAlias).LastUpdate = Utility.GetCurrentGameTime()
			EndIf
			;Debug.Trace("_MWA_: BrokenUpdate: Alias(" + i + ") - " + CurrentAlias.GetReference().GetBaseObject().GetName() + ". LastUpdate: " + (CurrentAlias as _MWA_ArmorAlias).LastUpdate)
		Else
			;Debug.Trace("_MWA_: BrokenUpdate: Alias(" + i + ") - None. LastUpdate: " + (CurrentAlias as _MWA_ArmorAlias).LastUpdate)
		EndIf
		i += 1
	EndWhile
	;float ftimeEnd = Utility.GetCurrentRealTime()
	;Debug.Trace("_MWA_: BrokenUpdate: Took " + (ftimeEnd - ftimeStart) + " seconds to run")
	RegisterForSingleUpdateGameTime(1.0)
EndEvent

Function BeginUpdates()
	RegisterForSingleUpdateGameTime(1.0)
EndFunction

Quest Property _MWA_BrokenTrack Auto
