Scriptname _MWA_ObjectEquipMonitor extends ReferenceAlias  

_MWA_DestructionTypes Property DestructTypes Auto
_MWA_Utility Property Util Auto
_MWA_SanityChecker Property SanityChecker Auto
_MWA_Mcm Property Menu Auto
_MWA_Init Property Init Auto
_MWA_InterfaceDeviousDevices Property Devious Auto

Actor Property PlayerRef Auto

; NEEDS REVIEW ============================================
Function GoToPauseState()
	GoToState("Pause")
EndFunction

Function GoToEmptyState()
	GoToState("")
EndFunction
; ==========================================================

Event OnObjectEquipped(Form akBaseObject, ObjectReference akReference)
	;Debug.Trace("_MWA_: Initial Equipped: " + akBaseObject.GetName() + " -  FormId: " + akBaseObject + ". Objref: " + akReference)
	;If akBaseObject as Hazard ; How the fuck are HAZARDS making it into the wornlist?!?!?!
	;	Debug.Messagebox("_MWA_: Hazard: akBaseObject: " + akBaseObject + ". akReference: " + akReference)
	;EndIf	
	If DestructTypes.IsDestructible(akBaseObject)
		If akReference != None && StringUtil.Find(akReference, "in container") == -1
			;Debug.Trace("_MWA_: Equipped 2: " + akBaseObject.GetName() + " -  FormId: " +akBaseObject + ". Objref: " + akReference)
			
			If StorageUtil.GetIntValue(akReference, "_MWA_IsCursedObject", Missing = -1) == 1
				;Debug.Messagebox("Cursed")
				Devious.PoofToDevice(akBaseObject, akReference)
			EndIf
			
			;Debug.Messagebox("NOT Cursed")
			Float CurrentHealth = Util.GetWornObjectHealth(akReference, akBaseObject)
			Float RecordedHealth = StorageUtil.GetFloatValue(akReference, "_MWA_LastHealth", -1.0)
			If RecordedHealth != -1.0
				;Debug.Messagebox("CurrentHealth: " + CurrentHealth + ". RecordedHealth: " + RecordedHealth + ". Next upgrade threshold: " + Init.GetUpgradedTemperHealth(RecordedHealth))
				If CurrentHealth >= Init.GetUpgradedTemperHealth(RecordedHealth)
					;Debug.Messagebox("Bump It")
					Util.BumpTempering(akReference, akBaseObject, CurrentHealth)
					If Menu.TemperingRefitT
						Util.FitToPlayer(akReference, akBaseObject)
					EndIf
					Util.RestoreDurability(akReference, akBaseObject, CurrentHealth)
					StorageUtil.SetFloatValue(akReference, "_MWA_LastHealth", Util.GetWornObjectHealth(akReference, akBaseObject))
					;Debug.Notification("Item was tempered: " + CurrentHealth)
					;Debug.Messagebox("OldHealth: " + CurrentHealth + ". RecordedHealth: " + RecordedHealth + "NewHealth: " + Util.GetWornObjectHealth(akReference, akBaseObject))
					
				;Else
				;	Debug.Messagebox("NO Bump")
				EndIf
			Else
				StorageUtil.SetFloatValue(akReference, "_MWA_LastHealth", CurrentHealth)
			EndIf
			If Util.IsSuitable(akReference, akBaseObject)
				SanityChecker.BeginSanityCheck(akReference)
				
			Else
				PlayerRef.UnequipItem(akBaseObject, abPreventEquip = false,abSilent = true)
				Util.RefreshInventory()
			EndIf
		EndIf
	EndIf
EndEvent

Event OnObjectUnequipped(Form akBaseObject, ObjectReference akReference)
	If DestructTypes.IsDestructible(akBaseObject)
		If akReference != None && StringUtil.Find(akReference, "in container") == -1
			;Debug.Trace("_MWA_: Unequipped: " + akBaseObject.GetName() + " -  FormId: " +akBaseObject + ". Objref: " + akReference)
			SanityChecker.BeginSanityCheck(akReference)
		EndIf
	EndIf
EndEvent

State Pause
	Event OnObjectEquipped(Form akBaseObject, ObjectReference akReference)
	
	EndEvent

	Event OnObjectUnequipped(Form akBaseObject, ObjectReference akReference)
	
	EndEvent
EndState
